// b+  
//    
// ..   (, )
//
// -    , 
// -     
// -  ,    
// -    ( ,   )
//
// (   ,       )
// icq:133575351

/* ******
  :
        ,
         .
    b+.

[list_st]            // []   
data_st array[..];   //   (+ -      )
REF_TYPE next;       //       (   )

[data_st]            // []   
VAL_TYPE hash;       //  ,    
WORD     size1;      //   
WORD     size2;      //   
....     data;       //  


[data_nx_st]         // []  
...      data;	     // 
REF_TYPE next;       //  ,     .


     ,     . 
         : , , .
             .
      ,       
       .
*/


#include<stdio.h>
#include<malloc.h>
#include<memory.h>
#include<stdlib.h>

#define FILENAME "base.bin"	//!<  -
#define J_FILENAME "jr.bin"	//!<     (  ,   )
#define SECTOR_SIZE 0x100	//!<  
#define NODE_SIZE 	63		//!<    
#define LIST_SIZE 	63		//!<    
#define CACHE_CAPABLITY	4	//!<  
#define BINARY_LIST_FIND	//   
#define BINARY_NODE_FIND	//   
#define VERBOSE				//      
#define FREE_FILL			//    

#if CACHE_CAPABLITY<3
#error
#endif 

typedef unsigned short WORD;
typedef WORD VAL_TYPE;			//!<   
typedef WORD REF_TYPE;			//!<  

#ifdef _DEBUG
# define CHECK_SIZE 60000		//<!   
# define MAPCODE_FREE	0		//  
# define MAPCODE_USE	1		//  
# define MAPCODE_USEOK	2		//     
# define MAPCODE_ERR	3		//  ,    
# define FILENAME1 "map1.bin"	//     
# define FILENAME2 "map2.bin"	// ...
  char     map1[CHECK_SIZE];	//  
  VAL_TYPE map2[CHECK_SIZE];	// ...
#endif


struct head_st{ //  
	int sig;		// 
	int cluster;	//  
	int tree_root;	//  
	int tree_h;		//   (  )
	int count;		//    
	int free;		//   
}; 

struct free_st{int next;}; //  
struct node_cell_st{
	VAL_TYPE v; //     
	REF_TYPE p; //    
	};
struct list_cell_st{
	VAL_TYPE v; //  
	VAL_TYPE u; //  
	};
struct node_st{int count; node_cell_st arr[NODE_SIZE];}; // 
struct list_st{int count; list_cell_st arr[LIST_SIZE];}; // 

union sector_st{
	head_st head;
	free_st free;
	node_st node;
	list_st list;
	char    f[SECTOR_SIZE];
};	

#define FLAG_LOCK		1	//    (   )
#define FLAG_MODIFY		2	//  

class File{
	struct table_cell_st{
		int flags;			//!<  
		REF_TYPE nn;		//!<  
		sector_st *buff;	//!< 
	};
public:
	struct table_st{table_cell_st arr[CACHE_CAPABLITY];}*table; //!<    (       )
	bool head_modify;	//!<   
	int limit;			//!<  
	FILE *file;			//!<   
	head_st head;		//!<  
#ifdef J_FILENAME
	void Redo();		//!<          
#endif
	void CloseBase();								//!<  
	void SaveHead();								//!<  
	void LoadSector(REF_TYPE num,sector_st* buff);	//!<  
	void SaveSector(REF_TYPE num,sector_st* buff);	//!<  
	int  GetFreeSlot(int depth,REF_TYPE num);		//!<      
public:
	File();
	~File();
	int NewSector(int depth);						//!<   
	sector_st *OpenSector(int depth,REF_TYPE num,bool modify); //!<      
	inline list_st* OpenList(int depth,REF_TYPE num,bool modify) { return &OpenSector(depth,num,modify)->list;}
	inline node_st* OpenNode(int depth,REF_TYPE num,bool modify) { return &OpenSector(depth,num,modify)->node;}
	void OpenBase();								//!<      
	void SetModify(int depth,REF_TYPE num);			//!<    
	void RemoveSector(int depth,REF_TYPE num);		//!<        
	void Flush();									//!<     
	void IncH();									//!<   
	void DecH();									//!<   
	void ImmediateLoad(int depth,REF_TYPE num,sector_st* buff); //!<      
};	//!<  

class BTree:public File{
// ! @name    
// @[
	int FindInList(list_st *list,VAL_TYPE value,bool coincidence);	//!<    
	int FindInNode(node_st *node,VAL_TYPE value); //!<         
	inline REF_TYPE SplitList(int depth,REF_TYPE num1,list_cell_st slack); //!<  
	inline REF_TYPE SplitNode(int depth,REF_TYPE num1,node_cell_st slack); //!  
	inline REF_TYPE InsertToList(int depth,REF_TYPE num,VAL_TYPE value,VAL_TYPE user); //!<     (    )
	inline REF_TYPE InsertToNode(int depth,REF_TYPE num,int i,REF_TYPE ref,VAL_TYPE min); //!<     (    )
	inline void MergeList(int depth,REF_TYPE num1,REF_TYPE num2); //!<   
	inline void MergeNode(int depth,REF_TYPE num1,REF_TYPE num2); //!<   
	inline void RemoveFromNode(int depth,REF_TYPE num,int i); //!<    
	inline void PourNodeL(int depth,REF_TYPE num1,REF_TYPE num2); //!<   
	inline void PourNodeR(int depth,REF_TYPE num1,REF_TYPE num2); //!<   
	inline void PourListL(int depth,REF_TYPE num1,REF_TYPE num2); //!<   
	inline void PourListR(int depth,REF_TYPE num1,REF_TYPE num2); //!<   
	bool GetNeighbour(int depth,node_st* node,int *i1,int *i2); //!<     ,     
	void Balance(int depth,REF_TYPE num,int i1); //!<   (        )
// @]
// ! @name    
// @[
	int InsertSub(int depth,REF_TYPE num,VAL_TYPE value,VAL_TYPE user); //!<  ,  
	void RemoveSub(int depth,REF_TYPE num,VAL_TYPE value); //!<  ,  
// @]
#ifdef VERBOSE
// ! @name   
// @[
	void Show(int depth,REF_TYPE num); //!<  ,  
	void CheckMap(int depth,REF_TYPE num); //!<     ,  
	VAL_TYPE Check(int depth,REF_TYPE num,VAL_TYPE *seed); //!<   ,  
// @]
#endif
public:
// ! @name    
// @[
	void Init();	//!<    
	void Insert(VAL_TYPE value,VAL_TYPE user); //!<    
	void Remove(VAL_TYPE value); //!<   
	bool Query(VAL_TYPE value,VAL_TYPE *user);	//!<  
// @]
#ifdef VERBOSE
// ! @name     
// @[
	void Show(); //!<  
	void CheckMap(); //!<     
	void Check(); //!<   
// @]
#endif
}; //!<  

//==================================================================
//   

File::File()
{
#ifdef _DEBUG
	if(sizeof(sector_st)>SECTOR_SIZE) _asm { int 3 }
#endif
	file=0;
	table=0;
}

File::~File()
{
	head_modify=false;
	CloseBase();
	free(table);
}


void File::OpenBase()
{
	file=fopen(FILENAME,"r+b"); if(file) fread(&head,1,sizeof(head),file);
	else {
		file=fopen(FILENAME,"w+b");
		head.sig='TREE';
		head.cluster=SECTOR_SIZE;
		head.count=1;
		head.free=0;
		head.tree_h=-1;
		head.tree_root=0;
		fwrite(&head,1,sizeof(head),file);
	}
	limit=head.tree_h+1;
	if(limit) table=(table_st*)malloc(limit*sizeof(table_st)),memset(table,0,limit*sizeof(table_st));
#ifdef J_FILENAME	
	Redo();
#endif

}

void File::CloseBase()
{
	fclose(file);
}

#ifdef J_FILENAME	
//    
void File::Redo()
{
	FILE *file; int i; REF_TYPE chc,sectors,value,n,m,*list;
	union {
		REF_TYPE arr[SECTOR_SIZE/sizeof(REF_TYPE)];
		sector_st sector;
	};
	file=fopen(J_FILENAME,"rb"); if(!file) return;
	fread(&i,1,sizeof(i),file); // sig
	chc=0; value=1;
//  
	for(sectors=0;;sectors++) {
		if(!value) break;
		fread(&value,1,sizeof(value),file); // sig
		chc+=value;
	}
	fread(&value,1,sizeof(value),file); // chc
	if(chc!=value) goto exit;
	for(n=0; n<sectors; n++) {
		fread(&value,1,sizeof(value),file); // sector size
		fread(arr,value,sizeof(REF_TYPE),file);
		for(m=0; m<value; m++) chc+=arr[m];		
	}
	fread(&value,1,sizeof(value),file); // chc
	if(chc!=value) goto exit;
	rewind(file);
	list=(REF_TYPE*)alloca(sizeof(REF_TYPE)*(sectors+1));
	fread(&i,1,sizeof(i),file); // sig
	fread(list,sizeof(REF_TYPE),sectors+1,file);	// sectors list
	for(n=0; n<sectors; n++) {
		memset(arr,0,sizeof(arr));
		fread(&value,1,sizeof(value),file); // sector size
		fread(arr,value,sizeof(REF_TYPE),file);
		SaveSector(list[n],&sector);
	}
exit:
	fclose(file);
	remove(J_FILENAME);
}
#endif

void File::SaveHead()
{
	fseek(file,0,SEEK_SET);
	fwrite(&head,1,sizeof(head),file);
	head_modify=false;
}

//!    ,        .
//!      .
//!< \param depth   
//!< \param num    
//!! \result      
int File::GetFreeSlot(int depth,REF_TYPE num)
{
	int n,m,i;
	m=rand()%CACHE_CAPABLITY;
	for(n=0; n<CACHE_CAPABLITY; n++) {
		i=(n+m)%CACHE_CAPABLITY;
		if(table[depth].arr[i].flags&FLAG_LOCK) continue;
		table[depth].arr[i].nn=num;
		table[depth].arr[i].flags|=FLAG_LOCK|FLAG_MODIFY;
		if(!table[depth].arr[i].buff)table[depth].arr[i].buff=new sector_st;
		return i;
	}
	_asm { int 3 }
	return -1;
}

//!< \param depth   
//!< \param num    
//!< \param modify     
sector_st *File::OpenSector(int depth,REF_TYPE num,bool modify)
{
	int n,i;
	for(n=0; n<CACHE_CAPABLITY; n++) if(table[depth].arr[n].nn==num) {
		table[depth].arr[n].flags|=FLAG_LOCK; 
		if(modify) table[depth].arr[n].flags|=FLAG_MODIFY;
		return table[depth].arr[n].buff;
	}
	i=GetFreeSlot(depth,num); if(i<0) return 0;
	LoadSector(num,table[depth].arr[i].buff);
	return table[depth].arr[i].buff;
}

//!< \param depth   
//!< \param num    
void File::SetModify(int depth,REF_TYPE num)
{
	int n;
	for(n=0; n<CACHE_CAPABLITY; n++) if(table[depth].arr[n].nn==num) table[depth].arr[n].flags|=FLAG_MODIFY;
}

//!       ,   .
void File::Flush()
{
	int n,m;
#ifdef J_FILENAME	//   (      )
	FILE *file; int i;
	REF_TYPE chc,count; 
	REF_TYPE *buff,arr[SECTOR_SIZE/sizeof(REF_TYPE)];
	file=fopen(J_FILENAME,"wb");
	n='REDO';
	fwrite(&n,1,sizeof(n),file);	// 
	chc=0;
	for(n=0; n<=head.tree_h; n++)	//  
		for(m=0; m<CACHE_CAPABLITY; m++) 
			if(table[n].arr[m].flags&FLAG_MODIFY) {
				chc+=table[n].arr[m].nn;
				fwrite(&table[n].arr[m].nn,1,sizeof(REF_TYPE),file);
			}
	count=0;
	fwrite(&count,1,sizeof(count),file);	//  
	fwrite(&chc,1,sizeof(chc),file); //  
	//  
	for(n=0; n<=head.tree_h; n++)for(m=0; m<CACHE_CAPABLITY; m++)if(table[n].arr[m].flags&FLAG_MODIFY) {
		buff=(REF_TYPE*)table[n].arr[m].buff;
		for(i=0,count=0; i<SECTOR_SIZE/sizeof(REF_TYPE); i++) {chc+=buff[i]; if(buff[i]) count=i+1;}
		fwrite(&count,1,sizeof(count),file);	//  
		fwrite(buff,count,sizeof(REF_TYPE),file);
	}
	//  	
	memset(arr,0,sizeof(arr));
	memcpy(arr,&head,sizeof(head));
	for(i=0,count=0; i<SECTOR_SIZE/sizeof(REF_TYPE); i++) {chc+=arr[i]; if(arr[i]) count=i+1;}
	fwrite(&count,1,sizeof(count),file);	//  
	fwrite(&arr,count,sizeof(REF_TYPE),file);
	fwrite(&chc,1,sizeof(chc),file); //  
	fclose(file);
#endif
	for(n=0; n<=head.tree_h; n++) for(m=0; m<CACHE_CAPABLITY; m++) {
		if(table[n].arr[m].flags&FLAG_MODIFY) SaveSector(table[n].arr[m].nn,table[n].arr[m].buff);
		table[n].arr[m].flags=0;
	}
	if(head_modify) SaveHead();
#ifdef J_FILENAME
	remove(J_FILENAME);
#endif
}

//!< \param num   
//!< \param buff   ,   
void File::LoadSector(REF_TYPE num,sector_st* buff)
{
	fseek(file,num*SECTOR_SIZE,SEEK_SET);
	fread(buff,1,sizeof(sector_st),file);
}

//!< \param num   
//!< \param buff   ,   
void File::SaveSector(REF_TYPE num,sector_st* buff)
{
	fseek(file,num*SECTOR_SIZE,SEEK_SET);
#ifdef _DEBUG
	if(ftell(file)!=num*SECTOR_SIZE) _asm { int 3 }
#endif
	fwrite(buff,1,sizeof(sector_st),file);
}

//! (   )
void File::IncH()
{
	int n;
	head_modify=true;
	if(head.tree_h+1<=limit) limit+=limit/4+1,table=(table_st*)realloc(table,limit*sizeof(table_st));
	head.tree_h++;
	for(n=head.tree_h; n>0; n--) table[n]=table[n-1];
	memset(table,0,sizeof(table_st));
}

//! (   )
void File::DecH()
{
	int n;
	head_modify=true;
	for(n=0; n<CACHE_CAPABLITY; n++) delete table[0].arr[n].buff;
	for(n=0; n<head.tree_h; n++) table[n]=table[n+1];
	head.tree_h--;
}

//!<   ,            .
//!<         OpenSector
//!< \param depth   
//!< \result   
int File::NewSector(int depth)
{
	int m,n;
	if(!head.free) { 
		n=head.count++; //   ,  
		m=GetFreeSlot(depth,n);	//      ,     
		memset(table[depth].arr[m].buff,0,sizeof(sector_st));
	} else {	//       
		n=head.free;
		sector_st *sector=OpenSector(depth,head.free,true);
		head.free=sector->free.next;
	}
	head_modify=true;
	return n;
}

//!      ,       
//! \param depth   
//! \param num   
//! \param buff   ,   
void File::ImmediateLoad(int depth,REF_TYPE num,sector_st *sector)
{
	int n;
	for(n=0; n<CACHE_CAPABLITY; n++) if(table[depth].arr[n].nn==num) {
		memcpy(sector,table[depth].arr[n].buff,sizeof(sector_st));
		return;
	}
	LoadSector(num,sector);
}

//! \param depth   
//! \param num   
void File::RemoveSector(int depth,REF_TYPE num)
{
	int n; sector_st *buff=0;
	for(n=0; n<CACHE_CAPABLITY; n++) if(table[depth].arr[n].nn==num) {buff=table[depth].arr[n].buff; break;}
	if(!buff) {
		n=GetFreeSlot(depth,num);
		buff=table[depth].arr[n].buff;
	}
#ifdef FREE_FILL
	memset(buff,0,sizeof(sector_st));
#endif
	buff->free.next=head.free;	//     
	head.free=num;
	head_modify=true;
}

//==================================================================
//    

//         
//! \param list     
//! \param value  
//! \param coincidence =true   , =false   
//! \result      (-1    )
int BTree::FindInList(list_st *list,VAL_TYPE value,bool coincidence)
{
#ifdef BINARY_LIST_FIND
	int a,b,c;
	a=0;
	b=list->count-1;
	while(a<=b) {
		c=(a+b)/2;
		if(list->arr[c].v==value) return coincidence?c:-1;
		if(list->arr[c].v<value) a=c+1; else b=c-1;	
	}
	return coincidence?-1:a;
#else
	int i;
	for(i=0; i<list->count; i++) {
		if(list->arr[i].v==value) return coincidence?i:-1;
		if(list->arr[i].v>value) break;
	} 
	return coincidence?-1:i;
#endif
}

//         
//! \param node     
//! \param value  
//! \result   
int BTree::FindInNode(node_st *node,VAL_TYPE value)
{
#ifdef BINARY_NODE_FIND
	int a,b,c;
	a=0;
	b=node->count-1;
	while(a<=b) {
		c=(a+b)/2;
		if(node->arr[c].v<=value) a=c+1; else b=c-1;	
	}
	return a;
#else
	int i;
	for(i=0; i<node->count; i++) if(value<node->arr[i].v) break;
	return i;
#endif
}


//  
//! \param depth   
//! \param num   
//! \param slack  ,     
//! \result    
inline REF_TYPE BTree::SplitList(int depth,REF_TYPE num,list_cell_st slack)
{
	int i;
	REF_TYPE n=NewSector(depth);
	list_st *list1=OpenList(depth,num,true);
	list_st *list2=OpenList(head.tree_h,n,true);
	for(i=0; i<LIST_SIZE/2; i++) list2->arr[i]=list1->arr[i+(LIST_SIZE+1)/2];
	list2->arr[i++]=slack; list2->count=i;
	list1->count=(LIST_SIZE+1)/2;
#ifdef FREE_FILL
	for(i=(LIST_SIZE+1)/2; i<LIST_SIZE; i++) list1->arr[i].v=0,list1->arr[i].u=0;
#endif
	return n;
}


//  
//! \param depth   
//! \param num   
//! \param slack  ,     
//! \result    
inline REF_TYPE BTree::SplitNode(int depth,REF_TYPE num1,node_cell_st slack)
{
	int i;
	REF_TYPE n=NewSector(depth);
	node_st *node1=OpenNode(depth,num1,true);
	node_st *node2=OpenNode(depth,n   ,true);
	for(i=0; i<NODE_SIZE/2; i++) node2->arr[i]=node1->arr[i+(NODE_SIZE+1)/2];
	node2->arr[i++]=slack; node2->count=i;
	node1->count=(NODE_SIZE+1)/2;
#ifdef FREE_FILL
	for(i=(NODE_SIZE+1)/2; i<NODE_SIZE; i++) node1->arr[i].v=0,node1->arr[i].p=0;
#endif
	return n;
}

//     (    )
//! \param depth   
//! \param num   
//! \param value   
//! \param user   
//! \result   ,       0
inline REF_TYPE BTree::InsertToList(int depth,REF_TYPE num,VAL_TYPE value,VAL_TYPE user)
{
	int n,i; list_cell_st slack;
	list_st *list=OpenList(depth,num,true);
	i=FindInList(list,value,false); if(i<0) {
		i=FindInList(list,value,true); if(i<0) return 0;	//     ,      
		list->arr[i].u=user;
		return 0;
	}
	slack=list->arr[LIST_SIZE-1];	//   
	n=list->count; if(n==LIST_SIZE) n--;
	for(; n>i; n--) list->arr[n]=list->arr[n-1];
	if(i<LIST_SIZE) list->arr[i].v=value,list->arr[i].u=user; 
	else slack.v=value,slack.u=user;
	list->count++;
	if(list->count<=LIST_SIZE) return 0;
	return SplitList(depth,num,slack);	//     
}

//     (    )
//! \param depth   
//! \param num   
//! \param i      
//! \param ref  
//! \param min   
//! \result   ,       0
inline REF_TYPE BTree::InsertToNode(int depth,REF_TYPE num,int i,REF_TYPE ref,VAL_TYPE min)
{
	int n;
	node_st *node=OpenNode(depth,num,true);
	node_cell_st slack_n=node->arr[NODE_SIZE-1];
	n=node->count; if(n==NODE_SIZE) n--;
	for(; n>i+1; n--) node->arr[n]=node->arr[n-1];
	if(i<NODE_SIZE-1) node->arr[i+1].v=min,node->arr[i+1].p=ref;
	else slack_n.p=ref,slack_n.v=min;
	node->count++;
	if(node->count<=NODE_SIZE) return 0;
	return SplitNode(depth,num,slack_n);
}

//   
//! \param depth   
//! \param num1  
//! \param num2  
inline void BTree::MergeList(int depth,REF_TYPE num1,REF_TYPE num2)
{
	int n,m;
	list_st *list1=OpenList(depth,num1,true);
	list_st *list2=OpenList(depth,num2,true);
	n=list1->count;
	for(m=0; m<list2->count && n<LIST_SIZE; m++,n++) list1->arr[n]=list2->arr[m];
	list1->count=n;
	RemoveSector(depth,num2);
}

//   
//! \param depth   
//! \param num1  
//! \param num2  
inline void BTree::MergeNode(int depth,REF_TYPE num1,REF_TYPE num2)
{
	int n,m;
	node_st *node1=OpenNode(depth,num1,true);
	node_st *node2=OpenNode(depth,num2,true);
	n=node1->count;
	for(m=0; m<node2->count && n<NODE_SIZE; m++,n++) node1->arr[n]=node2->arr[m];
	node1->count=n;
	RemoveSector(depth,num2);
}

//    
//! \param depth   
//! \param num    
//! \param i       
inline void BTree::RemoveFromNode(int depth,REF_TYPE num,int i)
{
	int n;
	node_st *node=OpenNode(depth,num,true);
	for(n=i; n<node->count-1; n++) node->arr[n]=node->arr[n+1];
	node->count--;
#ifdef FREE_FILL
	node->arr[node->count].v=0,node->arr[node->count].p=0;
#endif
}

//   
//! \param depth   
//! \param num1  
//! \param num2  
inline void BTree::PourNodeL(int depth,REF_TYPE num1,REF_TYPE num2)
{
	node_st *node1=OpenNode(depth,num1,true);
	node_st *node2=OpenNode(depth,num2,false);
	node1->arr[node1->count++]=node2->arr[0];
	RemoveFromNode(depth,num2,0);
}

//   
//! \param depth   
//! \param num1  
//! \param num2  
inline void BTree::PourNodeR(int depth,REF_TYPE num1,REF_TYPE num2)
{
	node_st *node1=OpenNode(depth,num1,true);
	node_st *node2=OpenNode(depth,num2,false);
	int n=--node1->count;
#ifdef _DEBUG
	if(n<0) _asm { int 3 }
#endif
	InsertToNode(depth,num2,-1,node1->arr[n].p,node1->arr[n].v);
#ifdef FREE_FILL
	node1->arr[n].v=0,node1->arr[n].p=0;
#endif
}

//   
//! \param depth   
//! \param num1  
//! \param num2  
inline void BTree::PourListL(int depth,REF_TYPE num1,REF_TYPE num2)
{
	int n;
	list_st *list1=OpenList(depth,num1,true);
	list_st *list2=OpenList(depth,num2,true);
	list1->arr[list1->count++]=list2->arr[0];
	for(n=1; n<list2->count; n++) list2->arr[n-1]=list2->arr[n];
	list2->count--;
#ifdef FREE_FILL
	list2->arr[list2->count].v=0,list2->arr[list2->count].u=0;
#endif
}

//   
//! \param depth   
//! \param num1  
//! \param num2  
inline void BTree::PourListR(int depth,REF_TYPE num1,REF_TYPE num2)
{
	int n;
	list_st *list1=OpenList(depth,num1,true);
	list_st *list2=OpenList(depth,num2,true);
	for(n=list2->count;n;n--) list2->arr[n]=list2->arr[n-1]; 
	list1->count--; list2->count++;
	list2->arr[0]=list1->arr[list1->count];	
#ifdef FREE_FILL
	list1->arr[list1->count].v=0,list1->arr[list1->count].u=0;
#endif
}

//     ,     
//! \param depth 
//! \param node  
//! \param i1     (   )
//! \param i2     
//! \param =true   
bool BTree::GetNeighbour(int depth,node_st* node,int *i1,int *i2)
{
	int mask=0;
	sector_st *ref1,*ref2;
	int count1,count2;
	if(*i1>0) mask|=1;
	if(*i1<node->count-1) mask|=2;
	switch(mask) {
	case 0: return true;
	case 1: *i2=(*i1)--; break;
	case 2: *i2=(*i1)+1; break;
	case 3: 
		ref1=OpenSector(depth+1,node->arr[(*i1)-1].p,false);
		ref2=OpenSector(depth+1,node->arr[(*i1)+1].p,false);
		if(depth==head.tree_h-1) count1=ref1->list.count,count2=ref2->list.count;
		else count1=ref1->node.count,count2=ref2->node.count;
		if(count1<count2) *i2=(*i1)+1; else *i2=(*i1)--; break;
	}
	return false;
}

//   (        )
//!       ,     
//! \param depth 
//! \param node  
//! \param i1    
void BTree::Balance(int depth,REF_TYPE num,int i1)
{
	sector_st *ref1,*ref2;
	int id1,id2,count1,count2,i2;
	node_st *node=OpenNode(depth,num,false);
	//      (    )
	if(GetNeighbour(depth,node,&i1,&i2)) return;
	id1=node->arr[i1].p; ref1=OpenSector(depth+1,id1,false);
	id2=node->arr[i2].p; ref2=OpenSector(depth+1,id2,false);
	if(depth==head.tree_h-1) { //   ,      
		count1=ref1->list.count;
		count2=ref2->list.count;
		if(count1+count2<=LIST_SIZE) { //    
			MergeList(depth+1,id1,id2);
			RemoveFromNode(depth,num,i2);
		} else
			if(abs(count1-count2)>1) { //  
			if(count1>count2) PourListR(depth+1,id1,id2); else PourListL(depth+1,id1,id2);
			node->arr[i2].v=ref2->list.arr[0].v;
			SetModify(depth,num);
		}
	} else {
		count1=ref1->node.count;
		count2=ref2->node.count;
		if(count1+count2<=NODE_SIZE) {	//  
			MergeNode(depth+1,id1,id2);
			RemoveFromNode(depth,num,i2);
		}else
		if(abs(count1-count2)>1) { //  
			if(count1>count2) PourNodeR(depth+1,id1,id2); else PourNodeL(depth+1,id1,id2);
			node->arr[i2].v=ref2->node.arr[0].v;
			SetModify(depth,num);
		}
	}
}



//==================================================================
//    

//  ,  
//! \param depth 
//! \param node  
//! \param value   
//! \param user   
//! \result     
int BTree::InsertSub(int depth,REF_TYPE num,VAL_TYPE value,VAL_TYPE user)
{
	static VAL_TYPE min1,min2; 
	union {list_st *list;node_st *node;}; 
	int n,m,ii; REF_TYPE i;
	if(depth==head.tree_h) {	
		//     
		i=InsertToList(depth,num,value,user); 
		list=OpenList(depth,num,false); min1=list->arr[0].v;
		if(!i) return 0;
		list=OpenList(depth,i,false);  min2=list->arr[0].v;
		min2=list->arr[0].v;
		goto exit;
	}
	//           (    )
	node=OpenNode(depth,num,false);
	min1=node->arr[0].v;
	ii=FindInNode(node,value); if(ii<0) return 0;
	if(ii) ii--;
	m=InsertSub(depth+1,node->arr[ii].p,value,user); //   
	if(node->arr[ii].v!=min1) SetModify(depth,num),node->arr[ii].v=min1;
	min1=node->arr[0].v;
	if(!m) { Balance(depth,num,ii); return 0;}
	//     
	i=InsertToNode(depth,num,ii,m,min2); if(!i) return 0;
	node=OpenNode(depth,i,false); min2=node->arr[0].v;
exit:
	if(depth) return i;	//   ,    .
	IncH();
	n=NewSector(0); 
	node=OpenNode(depth,n,true);
	node->count=2;
	node->arr[0].p=head.tree_root;
	node->arr[1].p=i;
	node->arr[0].v=min1;
	node->arr[1].v=min2;
	head.tree_root=n;
	return 0;
}


//  ,  
//! \param depth 
//! \param node  
//! \param value   
void BTree::RemoveSub(int depth,REF_TYPE num,VAL_TYPE value)
{
	static VAL_TYPE min; int n; 
	sector_st *sector=OpenSector(depth,num,false);
	if(depth==head.tree_h) {	
		//   ,    
		n=FindInList(&sector->list,value,true);
		if(n>=0) {
			SetModify(depth,num);
			for(;n<LIST_SIZE-1; n++) sector->list.arr[n]=sector->list.arr[n+1];
			sector->list.count--;
#ifdef FREE_FILL
			sector->list.arr[sector->list.count].v=0;
			sector->list.arr[sector->list.count].u=0;
#endif
		}
		min=sector->list.arr[0].v;
		return;
	}
	//     ,     
	n=FindInNode(&sector->node,value); n--; if(n<0) return;
	RemoveSub(depth+1,sector->node.arr[n].p,value); //   
	if(sector->node.arr[n].v!=min) sector->node.arr[n].v=min,SetModify(depth,num);
	Balance(depth,num,n);
	min=sector->node.arr[0].v;
}

//==================================================================
//    

void BTree::Init()
{
	OpenBase();
}


//    
//! \param value   
//! \param user   
void BTree::Insert(VAL_TYPE value,VAL_TYPE user)
{
	printf("insert: %d (%d)\n",(int)value,(int)user);
	if(!head.tree_root) {
		list_st *list;
		IncH();
		head.tree_root=NewSector(0);
		list=OpenList(0,head.tree_root,true);
		list->count=1;
		list->arr[0].v=value;	
		list->arr[0].u=user;
	} else InsertSub(0,head.tree_root,value,user); 
	Flush();
}

//   
//! \param value  
void BTree::Remove(VAL_TYPE value)
{
	REF_TYPE n;
	printf("remove: %d\n",(int)value);
	RemoveSub(0,head.tree_root,value);
	while(head.tree_h>0) { //      ,   
		node_st *node=OpenNode(0,head.tree_root,false);
		if(node->count!=1) break;
		n=head.tree_root; head.tree_root=node->arr[0].p; 
		DecH();
		RemoveSector(0,n);
	}
	Flush();
}

//     
//! \param value 
//! \param user    
//! \result =true   
bool BTree::Query(VAL_TYPE value,VAL_TYPE *user)
{
	int i,depth; REF_TYPE num;
	union{node_st *node; list_st *list;};
	num=head.tree_root;
	for(depth=0; depth<head.tree_h; depth++) {
		node=OpenNode(depth,num,false);
		i=FindInNode(node,value); i--; if(i<0) {Flush();return false;}
		num=node->arr[i].p;
	}
	list=OpenList(depth,num,false);
	i=FindInList(list,value,true); if(i<0) {Flush();return false;}
	*user=list->arr[i].u;
	Flush();
	return true;
}



//==================================================================
//    

#ifdef VERBOSE
//  ,  
//! \param depth 
//! \param node  
void BTree::Show(int depth,REF_TYPE num)
{
	int n,m; sector_st buff;
	ImmediateLoad(depth,num,&buff);
	for(n=0; n<depth*2; n++) putchar(' ');
	if(depth==head.tree_h) {
		printf("l%d:",num);
		for(n=0; n<buff.list.count; n++) printf(" %d",buff.list.arr[n].v);
		putchar('\n');
		return;
	}
	printf("n%d: ",num);
	for(m=0; m<buff.node.count; m++) {
		printf("[%d]",buff.node.arr[m].v);
		printf("%d",buff.node.arr[m].p);
	}
	putchar('\n');
	for(n=0; n<buff.node.count; n++) Show(depth+1,buff.node.arr[n].p);
}


//     ,  
//! \param depth 
//! \param node  
void BTree::CheckMap(int depth,REF_TYPE num)
{
	int n,v; sector_st sector;
	ImmediateLoad(depth,num,&sector);
	if(depth==head.tree_h) {
		for(n=0; n<sector.list.count; n++) { 
			v=sector.list.arr[n].v-1;
			map1[v]=map1[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
			if(map2[v]!=sector.list.arr[n].u) _asm { int 3 }
		}
		return;
	}
	for(n=0; n<sector.node.count; n++) CheckMap(depth+1,sector.node.arr[n].p);
}



//   ,  
//! \param depth 
//! \param node  
//! \param seed     (     )
//! \result     
VAL_TYPE BTree::Check(int depth,REF_TYPE num,VAL_TYPE *seed)
{
	int n; VAL_TYPE r,t; sector_st sector;
	ImmediateLoad(depth,num,&sector);
	if(depth==head.tree_h) {
		if(head.tree_h && sector.list.count<LIST_SIZE/2) _asm { int 3 }
		for(n=0; n<sector.list.count; n++) {
			if(sector.list.arr[n].v<=0 || sector.list.arr[n].v>CHECK_SIZE+1) _asm { int 3 }
			if(*seed<sector.list.arr[n].v) *seed=sector.list.arr[n].v; else _asm { int 3 }
		}
		return sector.list.arr[0].v;
	}
	r=-1;
	if(depth && sector.node.count<NODE_SIZE/2) _asm { int 3 }
	for(n=0; n<sector.node.count; n++) {
		t=Check(depth+1,sector.node.arr[n].p,seed);
		if(!n) r=t;
		if(sector.node.arr[n].v!=t) _asm { int 3 }
	}
	return r;
}


//==================================================================
//    

//  
void BTree::Show()
{
	printf("[show]\n");
	if(head.tree_root) Show(0,head.tree_root);
}



//     
//!   
void BTree::CheckMap()
{
	int n;
	CheckMap(0,head.tree_root);
	for(n=0; n<CHECK_SIZE; n++) switch(map1[n]) {
	case MAPCODE_FREE: break;
	case MAPCODE_USEOK: map1[n]=MAPCODE_USE; break;
	default: _asm { int 3 }
	}
}

//   
//!          .
//!       .
//!          .
//!   .
void BTree::Check()
{
	VAL_TYPE value=0;
	Check(0,head.tree_root,&value);
}


#endif


//  
void main()
{
	BTree tree;
#ifdef VERBOSE
	int n,v,u; FILE *file; VAL_TYPE user;
	file=fopen("map1.bin","rb");
	if(file) {
		fread(map1,1,sizeof(map1),file);
		fclose(file);
		file=fopen("map2.bin","rb");
		fread(map2,1,sizeof(map2),file);
		fclose(file);
		printf("check map\n");
		tree.Init();
		tree.Check();
		tree.CheckMap();
		printf("[done]\n");
		getchar();
		return;
	}
	remove(FILENAME);
	tree.Init();
	memset(map1,MAPCODE_FREE,sizeof(map1));
	for(n=0;n<CHECK_SIZE*2;n++) 
	{
		printf("[pass: %d]\n",n);
		v=rand()%CHECK_SIZE; map1[v]=MAPCODE_USE;  
		u=rand()%CHECK_SIZE; map2[v]=u;
		tree.Insert(v+1,u);
		tree.Check();
		tree.CheckMap();
		v=rand()%CHECK_SIZE; map1[v]=MAPCODE_FREE;
		tree.Remove(v+1);
		tree.Check();
		tree.CheckMap();
	}
	printf("[query]\n");
	for(n=0; n<CHECK_SIZE; n++) {
		switch(map1[n]) {
		case MAPCODE_USE:  
			if(!tree.Query(n+1,&user)) _asm { int 3 } 
			if(map2[n]!=user) _asm { int 3 }
			break;
		case MAPCODE_FREE: 
			if(tree.Query(n+1,&user)) _asm { int 3 } 
			break;
		default: _asm { int 3 }
		}
	}
	for(n=0; n<CHECK_SIZE; n++) {
		map1[n]=MAPCODE_FREE;
		tree.Remove(n+1);
		tree.Check();
		tree.CheckMap();
	}
	for(n=0;n<CHECK_SIZE;n++) 
	{
		printf("[pass: %d]\n",n);
		v=rand()%CHECK_SIZE; map1[v]=MAPCODE_USE;  
		u=rand()%CHECK_SIZE; map2[v]=u;
		tree.Insert(v+1,u);
		tree.Check();
		tree.CheckMap();
		v=rand()%CHECK_SIZE; map1[v]=MAPCODE_FREE;
		tree.Remove(v+1);
		tree.Check();
		tree.CheckMap();
	}
	file=fopen("map1.bin","wb");
	fwrite(map1,1,sizeof(map1),file);
	fclose(file);
	file=fopen("map2.bin","wb");
	fwrite(map2,1,sizeof(map2),file);
	fclose(file);
//	tree.Show();
#endif
	printf("[done]\n");
	getchar();
}


